-- %Z% %M% %I%.%B% %E% %U% 
-- %Z% %Q% 

CREATE OR REPLACE PACKAGE wm_LucQAS_AvailData_pkg as

  gTimeSlice Integer;

  PROCEDURE File_Loaded ( IN_System_ID  IN INTEGER,
                          IN_Q_QAS_ID   IN VARCHAR2,
			  IN_Regname    IN VARCHAR2,
			  IN_Cab_ID     IN VARCHAR2,
			  IN_Cha_ID     IN VARCHAR2,
			  IN_M_Element  IN VARCHAR2,
			  IN_F_Ent_ID   IN VARCHAR2,
                          IN_T_Stamp    IN VARCHAR2,
                          IN_File_Type  IN VARCHAR2,
                          IN_LoadResult IN VARCHAR2);
  
END wm_LucQAS_AvailData_pkg;
/
show errors;

CREATE OR REPLACE PACKAGE BODY wm_LucQAS_AvailData_pkg 
AS
  PROCEDURE File_Loaded ( IN_System_ID  IN INTEGER,
                          IN_Q_QAS_ID   IN VARCHAR2,
			  IN_Regname    IN VARCHAR2,
			  IN_Cab_ID     IN VARCHAR2,
			  IN_Cha_ID     IN VARCHAR2,
			  IN_M_Element  IN VARCHAR2,
			  IN_F_Ent_ID   IN VARCHAR2,
                          IN_T_Stamp    IN VARCHAR2,
                          IN_File_Type  IN VARCHAR2,
                          IN_LoadResult IN VARCHAR2)
  IS

  v_instance_id     NUMBER;
  v_TimeStamp       DATE;
  v_Entity_ID       NUMBER;
  vEvent_ID         NUMBER;
  v_FullKey         VARCHAR2(100);
  v_FullKeyID       VARCHAR2(100); 
  v_Frequency       wm_file_control.frequency%TYPE;
  v_EntityName      wm_file_control.entity_name%TYPE;
  v_SelectStmt      LONG;
  TYPE ref_cur_type IS REF CURSOR;
  lv_c2             ref_cur_type;

  BEGIN
   IF IN_LoadResult = 'loadOK '
   THEN
   -- Checking Parameters
    /*
    dbms_output.put_line('IN_System_ID is ('||IN_System_ID||')');
    dbms_output.put_line('IN_Q_QAS_ID is ('||IN_Q_QAS_ID||')');
    dbms_output.put_line('IN_Regname is ('||IN_Regname||')');
    dbms_output.put_line('IN_Cab_ID is ('||IN_Cab_ID||')');
    dbms_output.put_line('IN_Cha_ID is ('||IN_Cha_ID||')');
    dbms_output.put_line('IN_M_Element is ('||IN_M_Element||')');
    dbms_output.put_line('IN_F_Ent_ID is ('||IN_F_Ent_ID||')');
    dbms_output.put_line('IN_T_Stamp is ('||IN_T_Stamp||')');
    dbms_output.put_line('IN_File_Type is ('||IN_File_Type||')');
    dbms_output.put_line('IN_LoadResult is ('||IN_LoadResult||')');
    */
    -- Get File Info
    SELECT frequency, entity_name, entity_id
    INTO  v_Frequency, v_EntityName, v_Entity_ID
    FROM wm_file_control
    WHERE file_type = IN_File_Type;

    -- Checking SELECT Variables
    /*
    dbms_output.put_line('v_Frequency is ('||v_Frequency||')');
    dbms_output.put_line('v_EntityName is ('||v_EntityName||')');
    dbms_output.put_line('v_Entity_ID is ('||v_Entity_ID||')');
    */

    -- Preparing Variables
    gTimeSlice    := dataAvail.get_property('TimeSlices');    
    v_TimeStamp   := to_date(trim(In_T_Stamp), 'YYYYMMDDHH24MISS');
    v_FullKeyID   := trim(IN_System_ID)||'-'||trim(IN_Q_QAS_ID)||'-'||trim(IN_Regname)||'-';

    -- Checking Variables
    /*
    dbms_output.put_line('gTimeSlice is ('||gTimeSlice||')');
    dbms_output.put_line('v_TimeStamp is ('||v_TimeStamp||')');
    dbms_output.put_line('v_FullKey is ('||v_FullKey||')');
    dbms_output.put_line('v_instance_id is ('||v_instance_id||')');
    */
        -- APAR IZ43242- Data availability graph do not reflect availability of data in traffic tables.
        -- For Core data type: DFE, HAD, ESM
	IF (IN_File_Type = 'DFE')
	THEN
	    v_SelectStmt := 'SELECT DFE_ID from LU_TF_QCHAT_DFE_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' || 
			    '''' || trim(In_T_Stamp) || ''' and ' || 
                            ' DFE_ID like ''' || trim(v_FullKeyID) || '%'' ';
	ELSIF (IN_File_Type = 'HAD')
	THEN
	    v_SelectStmt := 'SELECT HAD_ID from LU_TF_QCHAT_HAD_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' HAD_ID like ''' || trim(v_FullKeyID) || '%'' ';
	ELSIF (IN_File_Type = 'ESM_Core_IF')
	THEN
	    v_SelectStmt := 'SELECT ESMQ_CORE_IF_ID from LU_TF_QCHAT_ESMQ_CORE_IF_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' ESMQ_CORE_IF_ID like ''' || trim(v_FullKeyID) || '%'' ';
        
	-- For Regional data type	
	ELSIF (IN_File_Type = 'CCD')
	THEN
	    v_SelectStmt := 'SELECT CCD_ID from LU_TF_QCHAT_CCD_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' || 
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' CCD_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'CID')
	THEN
	    v_SelectStmt := 'SELECT CID_ID from LU_TF_QCHAT_CID_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' CID_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'CRH')
	THEN
	    v_SelectStmt := 'SELECT CRH_ID from LU_TF_QCHAT_CRH_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' CRH_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'DCH')
	THEN
	    v_SelectStmt := 'SELECT DCH_ID from LU_TF_QCHAT_DCH_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' DCH_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'ESM_Regional_IF')
	THEN
	    v_SelectStmt := 'SELECT ESMQ_REGIONAL_IF_ID from LU_TF_QCHAT_ESM_REGION_IF_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' ESMQ_REGIONAL_IF_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'GCF')
	THEN
	    v_SelectStmt := 'SELECT GCF_ID from LU_TF_QCHAT_GCF_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' GCF_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'GCH')
	THEN
	    v_SelectStmt := 'SELECT GCH_ID from LU_TF_QCHAT_GCH_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' GCH_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'GCM')
	THEN
	    v_SelectStmt := 'SELECT GCM_ID from LU_TF_QCHAT_GCM_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' GCM_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'GMH')
	THEN
	    v_SelectStmt := 'SELECT GMH_ID from LU_TF_QCHAT_GMH_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' GMH_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'GSR')
	THEN
	    v_SelectStmt := 'SELECT GSR_ID from LU_TF_QCHAT_GSR_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' GSR_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'MCH')
	THEN
	    v_SelectStmt := 'SELECT MCH_ID from LU_TF_QCHAT_MCH_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' MCH_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'RGA')
	THEN
	    v_SelectStmt := 'SELECT RGA_ID from LU_TF_QCHAT_RGA_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' RGA_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'RMM')
	THEN
	    v_SelectStmt := 'SELECT RMM_ID from LU_TF_QCHAT_RMM_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' RMM_ID like ''' || trim(v_FullKeyID) || '%'' ';
        ELSIF (IN_File_Type = 'RULS')
	THEN
	    v_SelectStmt := 'SELECT RULS_ID from LU_TF_QCHAT_RULS_TAB ' ||
			    'WHERE TO_CHAR(TSTAMP,''YYYYMMDDHH24MISS'') = ' ||
			    '''' || trim(In_T_Stamp) || ''' and ' ||
                            ' RULS_ID like ''' || trim(v_FullKeyID) || '%'' ';
	END IF;

        -- Loop support multiple-instances for single data file
	OPEN lv_c2 FOR v_SelectStmt;
	 LOOP
	 FETCH lv_c2 INTO v_FullKey;
	 EXIT WHEN lv_c2%NOTFOUND;

	 v_FullKey     := UPPER(trim(v_FullKey));
	 v_instance_id := dataAvail.get_instance_id(v_Entity_ID,v_FullKey);

	 /*
	 dbms_output.put_line('v_FullKey is ('||v_FullKey||')');
	 dbms_output.put_line('v_instance_id is ('||v_instance_id||')');
	 dbms_output.put_line('------');
	 */

	 -- Inserting Rows
	 vEvent_ID := dataAvail.insert_event(v_TimeStamp, v_instance_id, v_Entity_ID, IN_File_Type);
		      dataAvail.insert_rows(IN_File_Type, v_Frequency, v_Entity_ID, v_TimeStamp, v_instance_id, gTimeSlice, vEvent_ID);
         END LOOP;
	CLOSE lv_c2;

   END IF;
  END File_Loaded;

END wm_LucQAS_AvailData_pkg;
/

show errors;
