-- %Z% %M% %I%.%B% %E% %U% 
-- %Z% %Q% 

CREATE OR REPLACE PACKAGE patchMissingDA as

   FUNCTION Insert_Event( In_Data_Tstamp IN date,
		          In_Instance_Id IN number,
		          In_Entity_Id   IN number,
		          In_File_Type   IN varchar2)
                          RETURN INTEGER;

   FUNCTION Get_File_Type_id( IN_File_Type IN Varchar2) RETURN number;
END patchMissingDA;
/
show errors;

CREATE OR REPLACE PACKAGE BODY patchMissingDA
AS

  FUNCTION Insert_Event( In_Data_Tstamp IN date,
			 In_Instance_Id IN number,
			 In_Entity_Id   IN number,
			 In_File_Type   IN varchar2)
			 RETURN INTEGER
  IS
    event_id INTEGER;
  BEGIN
      INSERT into en_event_data_load_v
      (event_id,
       event_time,
       data_tstamp,
       instance_id,
       entity_id,
       file_type_id)
      values
      (en_event_seq.nextval,
       sysdate,
       In_Data_Tstamp,
       In_Instance_Id,
       In_Entity_id,
       get_file_type_id(In_file_type));

      select en_event_seq.currval
      into event_id
      from dual;
		       
      RETURN event_id;
  END Insert_Event;

  FUNCTION get_file_type_id(IN_File_Type IN Varchar2)
  RETURN NUMBER
  IS
    CURSOR get_id IS
     select file_type_id
     from wm_file_control
     where file_type = In_File_Type;
    out_file_type_id number;
  BEGIN
    OPEN get_id;
    FETCH get_id into out_file_type_id;
    IF get_id%NOTFOUND then out_file_type_id :=0; END IF;
    CLOSE get_id;
    RETURN out_file_type_id;
  END get_file_type_id;
END patchMissingDA;
/

show errors;
